[toc]

# 千家研发中心中台设计概要


日期|版本|操作
---:|---|---
2020.1.10 | v 0.1 | ADD

## 1. 建设背景

为快速说明企业业务，千家研发中心自成立以来，一直在以微服务的形式持续迭代业务项目。并在一年的时间内采集了大量的业务数据。在一定时间内支撑了企业的运营的同时也带来了如下挑战：

### 1.1 数据规格不一致

由于各产品线在研发初期缺乏统一规划，*各业务项目之间的数据规格不一致*且缺乏有效的管理方法，落地的数据分散在各个业务数据库中且规格不一致，为后续的统计分析工作造成相当大的困扰。

### 1.2 新业务研发效率降低

由于业务数据保存在各业务系统数据库中，没有将公共数据以及处理这些公数据的能力进行沉淀，也造成了团队在数据服务能力方面的欠缺。无法为新业务的研发提供简洁、快速、有效的支撑。新开展的业务需要频繁和已有业务进行对接以获取所需数据，这在很大程度上限制了研发效率的提升，随着业务系统越来越多的上线，需要对接的接口也越来越多，研发效率将会越来越低。

目前平台架构还属于两层架构，即前台-后台架构模式，前台属于瘦前端，大多数的业务逻辑放到了后台。显而易见，这样的架构无法满足快速变化的业务需求。

我们需要一个“变速齿轮”来实现快速变化的前台业务和要求稳定的后台之间的过渡。前台系统接触用户，后台系统提供基础服务，两者需要一个灵活快速，一个需要稳定高效，两者在速率上并不匹配，制约了对用户需求的快速响应。

**因此，为了保障研发效率，以及数据分析工作乃至后续的智能化办公领域开发的顺利进行，千家研发中心将本着服务业务的主旨，围绕业务，展开企业中台建设。**

## 2. 解决方案

首先需要明确：**中台建设属架构建设， 而架构建设从来都不是一个纯技术方面的概念**

### 2.1 现状

如下图所示，团队建设初期，为了快速说明业务，各业务系统数据库相互独立。虽然快速上线了很多项目，但数据拓扑结构繁杂，耦合严重。

这也是当前很多团队在建设初期遇到的问题。

![image](https://git.allhome.com.cn/debuglife/DataDevCenter/raw/master/pics/%E4%BB%A5%E6%97%A5%E6%8A%A5%E4%B8%BA%E4%BE%8B%E7%9A%84%E7%8E%B0%E6%9C%89%E9%A1%B9%E7%9B%AE%E7%A0%94%E5%8F%91%E6%B5%81%E7%A8%8B.jpg)


### 2.2 蓝图

出于平台应用架构在面向<font color="red">数据分析需求</font>和<font color ="red">研发效率提升</font>方面“力有不逮”的事实，团队需要做出架构上的适应性调整，以同时满足上述两个方面的需求。

![image](https://git.allhome.com.cn/debuglife/DataDevCenter/raw/master/pics/%E6%95%B0%E6%8D%AE%E4%B8%AD%E5%8F%B0%E6%99%AF%E8%A7%82.jpg)

上述蓝图所描述的场景，即是当今大数据时代获得广泛应用的Kappa数据架构。兼容离线和实时两种数据处理方式。

tips：
>数据从底层的数据源开始，经过各种各样的格式进入大数据平台，在大数据平台中经过Kafka、Flume等数据组件进行收集，然后分成两条线进行计算。一条线是进入流式计算平台（例如 Storm、Flink或者Spark
Streaming），去计算实时指标；另一条线进入批量数据处理离线计算平台（例如Mapreduce、Hive，Spark SQL），去计算T+1的业务指标，这些指标通常需要隔日才能看见。

前面提到，各业务系统缺乏统一规划，数据规格不统一，需要在产品线设计层面花费更多精力，但这显然与怀抱急切需求的用户期望冲突，对于初创团队来说，也几乎没有时间去构建完备的架构对系统元数据加以管控。

Kappa数据架构的核心在于实时计算和批处理过程使用同一套代码，这对微服务架构
主导的研发平台来说，可谓是天作之和。我们完全可以采用平台工作流机制来避免各业务系统间的，各业务方法之间的强耦合。从而为`使用同一套代码`提供可能 。降低对业务系统的侵入性。

而`针对数据规格不统一的问题，则可以采用旁处理器的方式，单独开发项目管理系统和代码生成器方式进行规避。`

任何架构模式都不是银弹。

对于大数据量的实时数据来说，可能在窗口期来不及完成所有数据的处理，然而作为一种过渡架构，避免在架构设计变革的过程中对现有开发工作造成过大侵入，也不失为一种妥协的办法。

### 2.3 组织机构

中台建设首先是企业组织机构的变革，广义层面，对服务型企业来说，企业要对市场变化做出快速反应，就必须要具备快速调整能力，而具备这些能力的，服务于一线员工的所有部门均可称为中台。

而研发部门内部设置的中台研发组，则是面先前台业务研发系统的中台。概括的说，其主要职责是沉淀业务数据的公用服务能力，并将之沉淀为数据接口为前台业务系统提供支持。

但实际上，在分析企业业务数据特征，沉淀公用能力的过程中，**形成并迭代数据操作、管理规范，进而演化出成熟稳定的数据处理技术架构才是企业最具价值的财富。**

倘若将数据中台的工作当做普通的技术开发工作来做，各做各的功能，是很难将经验总结为规范从而服务于企业的。

## 3. 设计概要

我司中台设计的核心设计思想：**<font color="red">采用统一计算过程，处理离线和实时数据。</font>**

中台从来都不是一个单一的技术概念。所有的中台都是业务中台，而业务中台，更是离不开技术和数据的支撑，因此有了下面的等式：

**业务中台=公用业务能力=公共业务接口+数据中台+技术中台**

通过分析、沉淀数据的公用属性，抽象公共业务能力到中台，使得快速支撑前台业务研发成为可能。

![image](https://git.allhome.com.cn/debuglife/DataDevCenter/raw/master/pics/20190107-%E4%B8%AD%E5%8F%B0%E6%9E%B6%E6%9E%84%E5%B1%82%E6%AC%A1.jpg)

以下将针对中台架构中关键构成要素进行简单说明，包括：平台工作流、前台业务系统，公共业务接口（业务中台）、 统一计算过程、数据中台。

### 3.1 前台业务系统

前台系统直接面向用户，以往的开发模式中，开发阶段无中台能力可用，前台业务开发人员不得不自行解决从大前端到大后端的所有问题，如聚合分析运算，依赖方接口的硬编码引入等。这样一来，每当需求发生变更，开发人员不得不去项目中修改代码甚至修改流程。开发成本居高不下。

举例来说，我们可以将各领域的应收，应付等运算密集型能力沉淀为中台服务，并同时分离出聚合分析能力为后台分析服务，以接口的形式服务于前台。将这个能力封装成“变速齿轮”后，便可为前台业务系统研发提供中台能力支撑，从而达到快速支撑业务研发的目的。

这样做的好处不仅仅在于能力”复用“，前台系统研发人员将不再需要了解各自的应收应付业务并硬编码实现(应收应付的编写由熟悉该类业务的研发人员专司实现)，只需关注业务流程，实现或调用已有接口并使用其计算结果即可。

而前面提到的**工作流，则为业务流程方法之间的依赖关系解除了耦合。**

按照这个思路，前台业务系统的开发解除了接口耦合，更专注于流程方法的实现上。足以应对快速变更的用户业务。

### 3.2 公共业务接口（业务中台）

业务中台的公用能力沉淀问题，如[3.1 前台](#31-%e5%89%8d%e5%8f%b0%e4%b8%9a%e5%8a%a1%e7%b3%bb%e7%bb%9f)提到的例子，应收应付业务因其具备公用能力并提供业务服务，可将该能力提炼到**业务中台**，我称之为**统一计算过程**。之后，再充分利用**工作流系统**的节点编排能力，将“应收应付”这个“统一计算过程”能力编排到需要的业务系统中，实现真正意义上的**业务中台**。

>继续延伸，该应收应付中台服务，可在不侵入前台业务的情况下将数据进一步下沉至数据分析数据库，实施进一步的分析聚合，直接为上层用户提供决策分析依据。

这样的例子还有很多，如：
- 具备即时消息，非即时消息传递，历史消息记录，消息重发等能力的工单系统
- 具备根据各部门考勤规则和打卡信息的考勤系统
- 企业人员档案速查接口
- ...

简单来说，业务中台是各领域公用能力的集合，聚合**数据后台**提供的“细粒度”数据，以 API 的形式为前台系统的研发提供便利。这里所说的业务中台是一组数据服务集群，同时提供业务系统所需的“统一计算过程”并对外暴露接口，为中台其他系统提供进一步的数据分析能力。

需要强调的是，前台和中台业务数据直接写入数据后台，并基于这些数据形成细粒度的业务数据接口。中台数据来自于**数据后台**提供的“细粒度”数据。

简单来说，后台数据由前台业务系统写入，中台数据由后台数据提炼，并进行更进一步的分析。

基于此种架构，中台要做的事情其实远不止于此。后台元数据的缓存、Join等使用频繁的操作，均可在中台进行提炼和缓存，这些数据能力其实也是公共能力的一种。

架构的变革，势必会影响到开发模式。以往我们只需要使用CRUD模式即可完成一套并发要求不高的业务系统的研发。现在却不得不同时使用CQRS和CRUD两种模式，为此，研发部门还需要对数据操作进行标准封装，将这两种数据操作模式做成SDK供前台业务开发人员使用。

### 3.3 数据中台

如前所述，服务于前台业务系统的数据中台的主要职责是向前台系统提供业务数据接口。此类业务数据经过研发团队分析整理，将数据的公用服务能力抽象成数据接口，统一对外提供服务。界定该类接口的关键概念是其提供的数据是否具有公共服务能力。

举例来说，员工打卡数据存放到数据后台（未经加工处理的原始数据）后，经考勤规则过滤，计算出员工考勤数据，而考勤数据将服务于工资、日报等多个业务系统，所以我们将考勤数据放到数据中台，以接口的形式提高考勤数据的复用性。

### 3.4 数据后台

数据后台以直接暴露数据连接的方式，为前台和中台系统提供数据服务。

与中台数据不同，可以将后台数据看作是企业未经任何加工的元数据。各个数据采集系统（业务系统）将采集到的数据存放在后台，在反哺到中台的过程中加工成用户想要的各维度数据。

>出于性能考虑，我们可以建设配套缓存设施，以提高数据服务效率。缓存设施覆盖后台和中台，属于基础技术设施，不在这里多说。

### 3.5 平台工作流

说到中台建设，不可避免的要说到工作流。

系统、接口间的调用定义硬编码在各业务系统代码中，造成了系统、接口间的紧耦合。是沉淀业务公共能力的第一个障碍。

对于工作流的核心理解，主要在于三个方面：

- 管理产品线流程
  >在用户侧，以高度灵活的方式定义业务流程
- 解除接口耦合
  >从架构设计的角度对系统进行解耦，解除接口依赖
- 灵活控制数据流向
  >数据的流向和接口间调用关系可在工作流中进行定义，不再需要由前台业务端硬编码，也无需使用ETL工具到各个业务中抽取数据

下图演示了不依赖工作流的业务系统，业务流转过程中接口间的调用完全依赖硬编码。

![image](https://git.allhome.com.cn/debuglife/DataDevCenter/raw/master/pics/%E5%BA%94%E7%BC%96%E7%A0%81%E7%9A%84%E4%B8%9A%E5%8A%A1%E7%B3%BB%E7%BB%9F.png)


应用工作流之后，接口间的强依赖关系被解除，用户可自行在工作流系统中使用图形化的方式对业务流程进行定义。

![image](https://git.allhome.com.cn/debuglife/DataDevCenter/raw/master/pics/%E4%BD%BF%E7%94%A8%E5%B7%A5%E4%BD%9C%E6%B5%81%E7%9A%84%E4%B8%9A%E5%8A%A1%E7%B3%BB%E7%BB%9F.png)

**除定义业务流程外，流程中各节点产生的数据，也可以在工作流定义时配置并进行信息发布和消费，从而降低数据提取过程中对业务系统的侵入。**

### 3.6 统一计算过程

统一计算过程是业务系统中提炼出来的公共运算能力或者公共业务逻辑。

在平台架构中使用统一计算过程可以：

- 保证多产品线计算结果的一致性，降低研发成本
- 保障各项目业务逻辑运算结果和聚合分析结果的一致性
- 借助工作流系统的任务编排能力，将**统一计算过程**编排到**业务中台**的接口中，解除耦合，增强维护性

“统一计算过程“的提炼和沉淀要求工作人员具备一定的架构经验，对平台项目细节保持关注，敏锐洞察平台各系统中的公共能力，为后期的业务中台建设节约成本。

### 3.7 离线数据计算中心

对于实时要求不高的分析需求来说，离线数据计算已被证明是一种有效节约计算成本的方法。但无论是实时、准实时或是定时计算，均应使用同样的计算过程。见 [3.6 统一计算过程](#36-%e7%bb%9f%e4%b8%80%e8%ae%a1%e7%ae%97%e8%bf%87%e7%a8%8b)

### 3.8 小结

建设数据中后台的过程中，中台技术部门除建设和维护基础设施外，还应关注业务领域的用户需求，从水平方向上提炼系统功能，垂直层面上构建抽象层次，以建设更具扩展性和维护性的中台应用层，为用户节约研发成本，提高研发效率。

在数据流转的各个环节设置相应的规范，约定各类操作，以保障“大中台，小前台”架构的持续性，并作为质控部门审查的主要目标。

## 4. 整体架构设计

前面章节解释了[设计概要](#3-%e8%ae%be%e8%ae%a1%e6%a6%82%e8%a6%81)的架构示意图中各个组件的含义和边界。总结下来，中台的概念主要体现在两个方面：

- 对业务场景的抽象、提炼、沉淀的**共享服务能力**
- 前中后三层体系架构，在前台和后台之间插入中台架构，**平衡前台业务系统和后台服务的灵活与稳定**，达到`变速齿轮`的效果

接下来将从架构能力方面说明中台的架构实施过程。先来看一张图：

![image](./pics/中台架构能力说明.jpg)

### 4.1 大数据保障体系

大数据保障体系主要从两个角度来说：
- 数仓建模规范体系
- 保障数仓系统正常运行的运维和研发体系

#### 4.1.1 数仓建模规范体系

数仓建模，所指不仅是指数据从一端到另一端的操作过程，更应遵循一套完整的规范体系。以期解决数据流转过程中的痛点：

- 缺乏一套统一的研发体系来管理整个数据的研发过程
  >各种工具的堆积使用复杂繁乱，时间长了，数据的来源和去向谁都搞不清楚
- 不同数据操作人员对指标的理解不一致，导致计算口径有误
- 大数据组件开发要求高，普通业务去直接使用Hbase、ES等技术组件会产生如**数据孤岛**等各种问题
- 数据的批计算和流计算使用不同的计算模型，难以保持一致且研发成本高，应使用[统一计算过程](#34-%e7%bb%9f%e4%b8%80%e8%ae%a1%e7%ae%97%e8%bf%87%e7%a8%8b)
- 缺乏平台级别的统一规划，同一条数据实时和离线难以复用计算，每次开发任务都要重新梳理

正是由于上述**痛点**的存在，我司建设数据中台首先应：

- 成立数据研发部门，物理隔离业务开发人员和大数据操作环境
  >避免各个研发团队直接使用HBase,ES等技术组件，从源头上避免数据孤岛的产生
- 建立数据研发团队管理制度
  >工作有日志，遇到问题能找到日志和对应的负责人
- 建立数据操作规范，维护统一计算口径
- 登记[统一计算过程](#34-%e7%bb%9f%e4%b8%80%e8%ae%a1%e7%ae%97%e8%bf%87%e7%a8%8b)，复用数据计算过程

**数据治理**是保障数据开发工作有序进行的基础，目前有许多优秀的开源数据治理工具，可以考虑针对这些开源工具进行适合我司的二次开发以接入自研的MIS平台。

建立**数据事业部(组织机构设施)**，并辅以相应的**管理制度，操作流程和规范**，使工作可追溯。将用户的业务痛点和研发痛点扼杀在摇篮中，物理隔离前台和后台，并以技术手段衔接前台系统研发和后台元数据，真正意义上提高研发效率。

>正如康威定律的核心思想：”组织形式等同系统设计“。作为架构设计者，我们不希望存在复杂而需求易变的系统，因此我们选择接收这种易变性，寄希望于降低系统建设的复杂度。阿里提出的大中台和小前台，虽然是个不错的选择，但更应注意的是，组织是需要管理的，管理就意味着额外的成本。

#### 4.1.2 数仓系统运维和研发体系



### 4.2 数据项目研发流程

数据项目研发流程涵盖[整体架构设计](#4-%e6%95%b4%e4%bd%93%e6%9e%b6%e6%9e%84%e8%ae%be%e8%ae%a1)中的各个方面。


数据模型的研发，和普通业务系统的研发大体雷同但又稍有区别。

数据模型来源于业务需求，类似考勤类的指标的用户需求非常明确，而有的指标在用户侧来说是实验性质的，生成指标的数据还没有开始采集，这个时候，中台研发部门和业务研发部门可能需要同时启动各自的项目，一个负责出具指标需求，一个负责具体的数据采集项目研发。业务研发过程中，结合现有设施将数据ETL到目标设施，供数据研发部门分析。这是一个跨部门协作的过程。

因此，需**将数据研发部门和业务研发部门的协作方式迭代到原有研发流程规范中**，以确保实施过程顺利展开。

确定业务需求和流程后，数据研发部门需要确定数据粒度和维度，最终确定事实表（统指ODS,DWD,DWS,ADS等模型层次）。事实表的设计方案主要从应用需求、产出性能、存储成本、数据质量等几个角度考虑。

### 4.3 统一计算过程

**我们还应充分考虑统一计算过程的应用对平台架构的影响。**

#### 4.3.1 命令查询分离模式

根据[设计概要](#3-%e8%ae%be%e8%ae%a1%e6%a6%82%e8%a6%81)中有关架构的描述，将原有的业务数据库作为数据后台，将分析数据作为数据中台，势必会对原有的研发模式产生影响。

通常来讲，研发前台业务系统只需使用简单的CRUD（增删改查）即可满足一般的用户数据写入和简单的查询统计需求。纳入数据分析体系后，对原有研发模式的挑战在于分析数据和业务数据将分别取自不同的数据源，且不能跨库查询。

针对这个问题，我的建议是，在原有架构的研发模式上，增加CQRS（命令查询分离）模式。并由专人封装成开发友好的SDK工具包，降低业务研发人员的学习和使用成本。

**CQRS模式只在必要的时候使用。**

>CQRS最早来自于Betrand Meyer（Eiffel语言之父，开-闭原则OCP提出者）在 Object-Oriented Software Construction 这本书中提到的一种 命令查询分离(Command Query Separation,CQS) 的概念。其基本思想在于，任何一个对象的方法可以分为两大类：
>- 命令(Command):不返回任何结果(void)，但会改变对象的状态。
>- 查询(Query):返回结果，但是不会改变对象的状态，对系统没有副作用

> 更多信息，参考：[浅谈命令查询职责分离(CQRS)模式](https://cloud.tencent.com/developer/article/1091868)

#### 4.3.2 实时与离线，流批一体化计算

统一计算过程的另一个重要的影响就是实时与离线计算以及流批一体化计算过程。

在某些情况下，统一计算过程很可能只是一个美好的理想。随着业务的展开和数据需求的丰富，在有限的资源和时间成本的考量下，降低研发成本快速交付成果始终是软件工程化的主要目标。大数据架构下统一计算过程的应用为工程目标带来了新的挑战。好在我们的平台架构是基于微服务思想搭建的，将“统一计算过程”沉淀为服务是一个看上去不错的解决方案。

## 5. 技术选型

目前我司的OLAP工作主要面临以下问题：

- 直接基于MySql/Mongodb架构，查询效率低下
- 业务间计算口径不一致，数据复用率低，开发周期长，维护成本高
- 缺乏统一的维表和事实表，同主题下数据统计口径不一致
- 新增业务需要投入较大的成本才能获得基础的OLAP能力

经分析，我司现阶段用户的基础需求主要包括以下两点：

- 报表能力
- 初级阶段只需支持以“天”为维度的预计算

前台业务研发的基础需求：

- 降低研发人员学习和接入成本
- 提供OLAP查询接口，支持各种即席分析

为满足用户和各业务线的实际需求，参照小米和美团的大数据建设方案，制定了简化版本的OLAP方案，见[整体架构设计](#4-%e6%95%b4%e4%bd%93%e6%9e%b6%e6%9e%84%e8%ae%be%e8%ae%a1)。

该方案中，[Apache Kylin](http://kylin.apache.org/cn/) 是 On [Apache Druid](https://druid.apache.org/docs/latest/design/index.html) 的，之所以做出这个选择，主要出于：

- 学习成本高
- 维护HBase的成本高
- HBase作为Kylin的存储方案时，Kylin无法被需要的下游服务直接读取数据
- 需求场景中实时分析要求高，HBase更适合离线非实时分析

新生代的 [Apache Druid](http://druid.io/docs/0.10.0/design/index.html) 有如下特性值得我们注意：

- 列式存储，能够实现查询的投影下推，避免访问不需要的数据
- 对维度字段建立倒排索引，从而支持快速过滤
- 针对OLAP场景设计
- 文档多，社区活跃
- ETL方案成熟

此外，数仓建设也遵循业界通用的分层治理原则，将治理过程划分如下层次：

- ODS 操作数据层
- DWD 明细数据层
- DWS 汇总层
- ADS 应用数据层

>注：特定场景下，如上层ODS数据规划合理时，明细数据层和汇总数据层可并行计算处理

## 6. 数据建模

### 6.1 数据仓库发展阶段
数据仓库的发展大致经历了这样的三个过程：

![image](./pics/数据仓库发展的三个阶段.jpg)

- 简单报表
  >系统的主要目标是解决一些日常的工作中业务人员需要的报表，以及生成一些简单的能够帮助领导进行决策所需要的汇总数据。这个阶段的大部分表现形式为数据库和前端报表工具
- 数据集市
  >主要是根据某个业务部门的需要，进行一定的数据的采集，整理，按照业务人员的需要，进行多维报表的展现，能够提供对特定业务指导的数据，并且能够提供特定的领导决策数据
- 数据仓库
  >主要是按照一定的数据模型，对整个企业的数据进行采集，整理，并且能够按照各个业务部门的需要，提供跨部门的，完全一致的业务报表数据，能够通过数据仓库生成对对业务具有指导性的数据，同时，为领导决策提供全面的数据支持



### 6.2 建设数据模型的意义

数据仓库的建设和数据集市、简单报表建设的主要区别就在于数据模型的支持。

- 进行全面的业务梳理，改进业务流程
  >
- 建立全方位的数据视角，消灭信息孤岛和数据差异
  >
- 解决业务的变动和数据仓库的灵活性
  >
- 帮助数据仓库系统本身的建设
  >

尤其是基于当前微服务架构平台中多产品线同时研发的状况下，数据模型的建设，对于建设以数据中台为中心的业务中台，有着不可或缺的决定性的意义。

### 6.3 数仓模型建设层次

一般来说，数据仓库模型建设分为以下几个层次：

![image](./pics/数据仓库模型的层次划分.jpg)

在整个数据仓库的建模过程中，一般需要经历四个过程：

- 业务建模，生成业务模型，主要解决业务层面的分解和程序化
- 领域建模，生成领域模型，主要是对业务模型进行抽象处理，生成领域概念模型
- 逻辑建模，生成逻辑模型，主要是将领域模型的概念实体以及实体之间的关系进行数据库层次的逻辑化
- 物理建模，生成物理模型，主要解决逻辑模型针对不同关系型数据库的物理化以及性能等一些具体的技术问题

### 6.4 数仓建模阶段划分

![image](./pics/数仓建模阶段划分.jpg)

#### 6.4.1 业务建模

- 划分整个公司的业务，一般按照业务部门划分，进行各个部门之间业务工作的界定，理清各业务部门之间的关系
- 深入了解各个业务部门具体业务流程并将其程序化
- 对业务部门的工作流程和方法提出改进并程序化
- 数据建模的范围界定，整个数仓项目的目标和阶段划分

#### 6.4.2 领域概念建模

- 抽取关键业务概念，并将之抽象化
- 将抽取出的业务概念分组，按照业务主线聚合类似的分组概念
- 细化分组概念，理清分组概念内的业务流程并抽象化
- 理清分组概念之间的关联，形成完整的领域概念模型

#### 6.4.3 逻辑建模

- 业务概念实体化，并考虑其具体的属性
- 事件实体化，并考虑其属性内容
- 说明实体化，并考虑其属性内容


#### 6.4.4 物理建模

- 针对特定物理化平台，做出技术规划和调整
- 出于性能指标考虑，做出相应调整
- 针对管理需要，结合平台，做出相应调整
- 生成脚本并迭代完善



参考 [数据仓库建设中的数据建模方法](https://www.ibm.com/developerworks/cn/data/library/techarticles/dm-0803zhousb/index.html)

[PDMan 国产免费建模工具](https://my.oschina.net/skymozn/blog/1821184)

[开源建模工具 OpenSystemArchitect](http://www.codebydesign.com/ )

Data-Infomation-Knowledge-Wisdom
数据-信息-知识-智慧

hadoop - spark 

hive 利用 MapReduce作为计算引擎
Presto自己开发计算引擎
Druid自己开发索引和计算引擎

spark是开源的类hadoop mapreduce通用的并行计算框架，同样也是基于分布式计算，拥有Hadoop MapReduce的所有优点
不同的是，Sparck任务的中间计算结果可以缓存在内存中，因此Spark的速度更快。开发语言采用Scala，因此直接在上面做数据处理和分析的开发成本会比较高。适合非结构化的数据查询处理。Spark可以对任何Schema进行灵活操作，适合处理规模更大的批处理任务。

Ad hoc 是一个拉丁文常用短语。这个短语的意思是“特设的、特定目的的、即席的、临时的、将就的、专案的”。这个短语通常用来形容一些特殊的、不能用于其它方面的，为一个特定的问题、任务而专门设定的解决方案

Apache Drill 通过开源的方式实现了谷歌的Dremel。Drill架构的整个思想还是通过优化查询引擎，进行快速全表扫描，以快速返回结果。

Hive是一个基于Hadoop的数据仓库工具，可以将结构化的数据文件映射为一张数据库表，并提供简单的SQL查询功能，可以将SQL语句转换为MapReduce任务运行。Hive并不适合那些需要低延迟的应用。因为内部的MapReduce非常慢。所有尝试Hive的公司，最后都会转到Impala的应用。

Impala 是实时交互SQL大数据查询工具，可以直接从HDFS或HBase中用select，join和统计函数查询数据，降低了延迟。

Presto 主要解决SQL查询引擎的问题，将SQL查询转换成分布式任务。Presto不优化存储结构，而是直接访问HDFS或者其他数据存储层。

简单查了一下Impala和Presto的查询效率，貌似Impala在速度上要优于Presto，但数据源支持不如Presto多





---


### 3.x 数据中台（<font color="red">应放到详细设计章节</font>）

MySql作为关系型数据库，主要负责事务数据的落地，确保事务一致性。事务成功后，数据写入时产生的Binlog日志会被Cannal或Maxwell订阅，进入到Kafka队列（之所以选择Kafka队列，是因其消息可被重复消费，消费规则和行为均由开发端决定），最后，通过消费Kafka中的消息，数据进入Apache Druid，数据在这里进行初步处理，聚合与分析操作则可以选择前置或后置。

![image](https://git.allhome.com.cn/debuglife/DataDevCenter/raw/master/pics/%E4%B8%AD%E5%8F%B0%E6%8A%80%E6%9C%AF%E8%B7%AF%E7%BA%BF.jpg)

Apache Druid 特点：
- 列式存储
    >可以将列作为索引，为仅查看几列的查询提供了巨大的速度提升
- 高可用，高并发
- 集群扩展、缩小、删除、宕机都不会停止服务，全天候运行
- HA、Sql的并行化执行，可扩展、容灾等
- 支持1000+的并发用户，并提供隔离机制支持多租户模式
- 低延迟
    >Druid采用了列式存储、倒排索引、位图索引等关键技术，能够在亚秒级别内完成海量数据的过滤、聚合以及多维分析等操作
- 存储的同时聚合,采集数据的同时做好Sum,Count等操作
    >无论是实时数据消费还是批量数据处理，Druid在基于DataSource结构存储数据时即可选择对任意的指标列进行聚合操作

实施聚合分析的时机实际上取决于场景需求，一方面是实时性的需求，另一方面则是数据的公共能力是否需要提炼、沉淀；又或者，沉淀数据和聚合分析并返回数据是同时进行的。

结合企业现状，最终选择了 <font color="blue">`MySql + Kafka + Apache Druid`</font> 模型来快速支撑上层用户的决策分析需求。但这并不是最终的技术方案，事实上，技术架构总是在不断演化的。之所以选择这个模型，只因其足够简单，同时也因目前用户的数据量虽小，但却有着实时分析的需求场景。

综上，从组织机构的角度，中台是一个部门，专门负责分析、提炼业务公共能力；从架构角度，它应是一个提供数据接口的“层”，提供经过提炼的数据接口，这些待提炼的业务接口，来自于原来的“后台”。而原来的“后台”的职能，则演变为提供稳定高效的细粒度接口。

如此一来，架构将由原来的前台-后台两层架构，演变为“前台-中台-后台”三层架构。基于现有的微服务平台架构，我们有条件从“前台-后台”两层架构平滑过渡到“前-中-后台”三层架构。

#### 3.5.1 主要职能
数据中台的概念延伸自业务中台，结合当前平台架构现状，主要应包括以下几种能力：

- 业务数据的公用能力提炼
  1. 分离原有后台服务为中台和后台(业务部分为中台，基础数据部分为后台)  
  2. 后台细粒度接口的数据聚合，并以Rest接口的形式对前台系统提供服务
- 业务数据的实时/离线聚合分析能力

#### 3.5.2 数据的公用能力

维护数据中台过程中，一个需要设计师时刻保持警觉的问题是：数据公用能力的提炼太过随意，将业务个性化的数据随意提炼到中台，最后发展成专门面向某一领域或项目特有的“数据集市”，随着业务的变化和扩张，该集市体量越来越大，服务范围却越来越”专一“，最终不得不进行分拆或重建以适应新的领域需求。

因此，**数据公用能力的提炼不能仅依靠架构师的个人能力，需要制定边界明确的操作规范，避免上述情况的发生。**

#### 3.5.3 降低或压缩SQL的使用影响和范围

根据以往的经验，面向特定领域或项目的“数据集市”，通常会有自我闭环的趋势，力图减少对其他系统的依赖，逐步积累数据后必然进一步扩充功能。通过SQL批量集成数据的方式为基于集市的业务系统膨胀提供的土壤。

前台系统的数据直接落地到数据后台，中台与数据后台基于 API 进行同步阻塞（确保事务性）或异步非阻塞(非事务性)通讯，目的是为了解耦具体技术产品和数据模型。基于后台服务返回结果集完成各类SQL等效操作，**降低或者压缩SQL的使用影响和范围**，使前台不容易积累数据以独自完成业务需求，避免为“数据集市”的滋生提供土壤和养分，

>SQL是一种领域特定语言（DSL），虽然**很强大但并不是很好的工程语言**。由于它不能在内存中定义和操作复杂的数据结构，如果要做模块化的逻辑封装，模块的输入输出必须是数据库表，这就带来了 I/O 损耗，大量的模块化，必然带来导致 I/O 性能的显著下降。而这些模块存在的方式只是脚本，缺少治理工具，大量零散的模块如何管理也是一个难题。系统实施者必须在模块化和性能间权衡，性能是显性的，直接影响用户体验且有明确的度量指标；模块化是隐形的，而且缺少度量工具。因此实际工程中，很少真正做到逻辑的模块化，数据库表的层次不规范，甚至出现数千行 SQL 语句从源表加工数据直接写入结果表。由于缺少治理工具，规范难以执行，久而久之大家也就默认了这样的事实。

>**大范围使用SQL的代价是可测试性极差**，每次逻辑的变化都要通过对代码的修改来实现而并不是新增逻辑。试想一段上千行、逻辑纵横交错的 SQL 语句，要在其中修改某个单点逻辑，没有高覆盖率的单元测试用例，如何确保正确性，最终只能依靠细心和运气，代码质量必定是脆弱的，不能称为真正的工程化项目，治理和敏捷都无从谈起。

因此，**降低或者压缩SQL的使用影响和范围，用API代替SQL**成为建设中台数据设施的必选项。

#### 3.5.4 降低数据存储冗余

数据中台应“降低数据存储冗余”。前面提到，数据由前台系统直接落地到数据后台，中台数据由后台数据反哺而来。中台只保留用户、机构等维度数据，用于提升处理效率。

水平方向上来说，系统间数据冗余是业务逻辑重复开发的土壤；垂直方向来说，数据中台和后台之间的数据冗余，同样是数据孤岛的成因，因此，需要在顶层架构设计中尽量规避。

为此，**制定明确的设计规范，将用于提升处理的效率的冗余数据统一存储在特定数据设施中**，划分该类冗余数据和分析结果存储设施的边界。
